"use strict";
var constants = require("../constants");
var CreateProjectCommand = (function () {
    function CreateProjectCommand($projectService, $errors, $options, $stringParameterBuilder) {
        this.$projectService = $projectService;
        this.$errors = $errors;
        this.$options = $options;
        this.$stringParameterBuilder = $stringParameterBuilder;
        this.enableHooks = false;
        this.allowedParameters = [this.$stringParameterBuilder.createMandatoryParameter("Project name cannot be empty.")];
    }
    CreateProjectCommand.prototype.execute = function (args) {
        var _this = this;
        return (function () {
            if (_this.$options.ng && _this.$options.template) {
                _this.$errors.fail("You cannot use --ng and --template simultaneously.");
            }
            var selectedTemplate = _this.$options.ng ? constants.ANGULAR_NAME : _this.$options.template;
            _this.$projectService.createProject(args[0], selectedTemplate).wait();
        }).future()();
    };
    return CreateProjectCommand;
})();
exports.CreateProjectCommand = CreateProjectCommand;
$injector.registerCommand("create", CreateProjectCommand);
