"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var DebugPlatformCommand = (function () {
    function DebugPlatformCommand(debugService, $devicesService, $errors, $options) {
        this.debugService = debugService;
        this.$devicesService = $devicesService;
        this.$errors = $errors;
        this.$options = $options;
        this.allowedParameters = [];
    }
    DebugPlatformCommand.prototype.execute = function (args) {
        return this.debugService.debug();
    };
    DebugPlatformCommand.prototype.canExecute = function (args) {
        var _this = this;
        return (function () {
            _this.$devicesService.initialize({ platform: _this.debugService.platform, deviceId: _this.$options.device }).wait();
            if (_this.$options.emulator) {
                return true;
            }
            if (_this.$devicesService.deviceCount === 0) {
                _this.$errors.failWithoutHelp("No devices detected. Connect a device and try again.");
            }
            else if (_this.$devicesService.deviceCount > 1) {
                _this.$errors.fail("Cannot debug on multiple devices. Select device with --device option.");
            }
            return true;
        }).future()();
    };
    return DebugPlatformCommand;
})();
exports.DebugPlatformCommand = DebugPlatformCommand;
var DebugIOSCommand = (function (_super) {
    __extends(DebugIOSCommand, _super);
    function DebugIOSCommand($iOSDebugService, $devicesService, $errors, $options) {
        _super.call(this, $iOSDebugService, $devicesService, $errors, $options);
    }
    return DebugIOSCommand;
})(DebugPlatformCommand);
exports.DebugIOSCommand = DebugIOSCommand;
$injector.registerCommand("debug|ios", DebugIOSCommand);
var DebugAndroidCommand = (function (_super) {
    __extends(DebugAndroidCommand, _super);
    function DebugAndroidCommand($androidDebugService, $devicesService, $errors, $options) {
        _super.call(this, $androidDebugService, $devicesService, $errors, $options);
    }
    return DebugAndroidCommand;
})(DebugPlatformCommand);
exports.DebugAndroidCommand = DebugAndroidCommand;
$injector.registerCommand("debug|android", DebugAndroidCommand);
